<?php
/*
 * MERETHIS
 *
 * Source Copyright 2005-2009 MERETHIS
 *
 * Unauthorized reproduction, copy and distribution
 * are not allowed.
 *
 * For more information : contact@merethis.com
 *
*/

require_once ("DB.php");

class SyslogDB {		
	private $db_type = "mysql";
	private $retry;
	private $privatePearDB;
	private $dsn;
	private $options;
	
	/*
	 *  Constructor only accepts 1 parameter which can be :
	 *  - centreon or NULL
	 *  - centstorage
	 *  - ndo
	 */
    function SyslogDB($db = "centreon", $retry = 3) {
		global $conf_centreon;		

		$this->retry = $retry;				
		$this->options = array('debug' => 2,'portability' => DB_PORTABILITY_ALL ^ DB_PORTABILITY_LOWERCASE);
		switch (strtolower($db)) {
			case "centreon" : 				
				$this->connectToCentreon($conf_centreon);
				$this->connect();
				break;
			case "centstorage" :
				$this->connectToCentstorage($conf_centreon);
				$this->connect();
				break;
			case "ndo" : 
				$this->connectToCentreon($conf_centreon);
				$this->connect();
				$this->connectToNDO($conf_centreon);
				$this->connect();
				break;				
			case "syslog" : 
				$this->connectToCentreon($conf_centreon);
				$this->connect();
				$this->connectToSyslog($conf_centreon);
				$this->connect();
				break;
			case "default" : 
				$this->connectToCentreon($conf_centreon);
				$this->connect();
				break;
		}		
    }
    
    /*
     *  Get info to connect to Centreon DB
     */
    private function connectToCentreon($conf_centreon) {		
		$this->dsn = array(
	    	'phptype'  => $this->db_type,
	    	'username' => $conf_centreon["user"],
	    	'password' => $conf_centreon["password"],
	    	'hostspec' => $conf_centreon["hostCentreon"],
	    	'database' => $conf_centreon["db"],
		);		
    }
    
    /*
     *  Get info to connect to Centstorage DB
     */
    private function connectToCentstorage($conf_centreon) {
    	$this->dsn = array(
	    	'phptype'  => $this->db_type,
	    	'username' => $conf_centreon["user"],
	    	'password' => $conf_centreon["password"],
	    	'hostspec' => $conf_centreon["hostCentstorage"],
	    	'database' => $conf_centreon["dbcstg"],
		);
    }
    
    /*
     *  Get info to connect to NDO DB
     */
    private function connectToNDO($conf_centreon) {		
		$DBRESULT =& $this->privatePearDB->query("SELECT db_name, db_prefix, db_user, db_pass, db_host FROM cfg_ndo2db LIMIT 1;");
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br />";
		$confNDO = $DBRESULT->fetchRow();
		unset($DBRESULT);
		
		$this->dsn = array(
	    	'phptype'  => $this->db_type,
	    	'username' => $confNDO['db_user'],
	    	'password' => $confNDO['db_pass'],
	    	'hostspec' => $confNDO['db_host'],
	    	'database' => $confNDO['db_name'],
		);
    }
    
    private function connectToSyslog($conf_centreon) {
    	$DBRESULT =& $this->privatePearDB->query("SELECT syslog_db, syslog_server_db_user, syslog_server_db_password, syslog_server FROM `mod_syslog_opt` LIMIT 1;");
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br />";
		$confSyslog = $DBRESULT->fetchRow();
		unset($DBRESULT);
		
		$this->dsn = array(
	    	'phptype'  => $this->db_type,
	    	'username' => $confSyslog['syslog_server_db_user'],
	    	'password' => $confSyslog['syslog_server_db_password'],
	    	'hostspec' => $confSyslog['syslog_server'],
	    	'database' => $confSyslog['syslog_db'],
		);
    }
    /*
     *  The connection is established here
     */
    public function connect() {    	    	    	
    	global $oreon;
    	
    	$this->privatePearDB =& DB::connect($this->dsn, $this->options);
		$i = 0;
		while (PEAR::isError($this->privatePearDB) && ($i < $this->retry)) {
			$this->privatePearDB =& DB::connect($this->dsn, $this->options);
			$i++;
		}
		$this->privatePearDB->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    
    /*
     *  Disconnection
     */
    public function disconnect() {
    	$this->privatePearDB->disconnect();
    }
    
    public function toString() {
    	return $this->privatePearDB->toString();
    }
    
    /*
     *  Query
     */
    public function query($query_string = NULL) {    	
    	global $oreon;
    	
    	$DBRES = $this->privatePearDB->query($query_string);    	
    	return $DBRES;
    }
}
?>