<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * Module name: Syslog
 * 
 * First developpement by : Jean Marc Grisard - Christophe Coraboeuf
 * 
 * Adaptation for Centreon 2.0 by : Merethis team 
 * 
 * SVN : $URL
 * SVN : $Id$
 * 
 */

	function getSyslogOpt()	{
		global $pearDB, $form;
		$syslog = array();

		$res =& $pearDB->query("SELECT * FROM `mod_syslog_opt` WHERE sopt_id = '1' LIMIT 1");
		if (PEAR::isError($pearDB)) {
			print "Mysql Error : ".$pearDB->getMessage();
		}
		/*
		 * Set base value
		 */
		$syslog = array_map("myDecode", $res->fetchRow());
		return $syslog;
	}

	function updateSyslogConfigData($sopt_id = null)	{
		global $form, $pearDB, $oreon;
		
		if (!$sopt_id) 
			return;
		
		$ret = array();
		$ret = $form->getSubmitValues();
		$rq = "UPDATE `mod_syslog_opt` SET ";
		$rq .= "syslog_server = ";
		isset($ret["syslog_server"]) && $ret["syslog_server"] != NULL ? $rq .= "'".htmlentities($ret["syslog_server"], ENT_QUOTES)."', ": $rq .= "NULL, ";
		
		$rq .= "syslog_db = ";
		isset($ret["syslog_db"]) && $ret["syslog_db"] != NULL ? $rq .= "'".htmlentities($ret["syslog_db"], ENT_QUOTES)."', ": $rq .= "NULL, ";
		
		$rq .= "syslog_db_table = ";
		isset($ret["syslog_db_table"]) && $ret["syslog_db_table"] != NULL ? $rq .= "'".htmlentities($ret["syslog_db_table"], ENT_QUOTES)."', ": $rq .= "NULL, ";
		
		$rq .= "syslog_db_filter = ";
		isset($ret["syslog_db_filter"]) && $ret["syslog_db_filter"] != NULL ? $rq .= "'".htmlentities($ret["syslog_db_filter"], ENT_QUOTES)."', ": $rq .= "NULL, ";
		
		$rq .= "syslog_db_rotate = ";
		isset($ret["syslog_db_rotate"]) && $ret["syslog_db_rotate"] != NULL ? $rq .= "'".htmlentities($ret["syslog_db_rotate"], ENT_QUOTES)."', ": $rq .= "NULL, ";
		
		$rq .= "syslog_conf_dir = ";
		isset($ret["syslog_conf_dir"]) && $ret["syslog_conf_dir"] != NULL ? $rq .= "'".htmlentities($ret["syslog_conf_dir"], ENT_QUOTES)."', ": $rq .= "NULL, ";
		
		$rq .= "syslog_shell_user = ";
		isset($ret["syslog_shell_user"]) && $ret["syslog_shell_user"] != NULL ? $rq .= "'".htmlentities($ret["syslog_shell_user"], ENT_QUOTES)."', ": $rq .= "NULL, ";
			
		$rq .= "syslog_ssh_port = ";
		isset($ret["syslog_ssh_port"]) && $ret["syslog_ssh_port"] != NULL ? $rq .= "'".htmlentities($ret["syslog_ssh_port"], ENT_QUOTES)."', ": $rq .= "NULL, ";
		
		$rq .= "syslog_shell_pass = ";
		isset($ret["syslog_shell_pass"]) && $ret["syslog_shell_pass"] != NULL ? $rq .= "'".htmlentities($ret["syslog_shell_pass"], ENT_QUOTES)."', ": $rq .= "NULL, ";
				
		$rq .= "syslog_server_db_user = ";
		isset($ret["syslog_server_db_user"]) && $ret["syslog_server_db_user"] != NULL ? $rq .= "'".htmlentities($ret["syslog_server_db_user"], ENT_QUOTES)."', ": $rq .= "NULL, ";
		
		$rq .= "syslog_server_db_password = ";
		isset($ret["syslog_server_db_password"]) && $ret["syslog_server_db_password"] != NULL ? $rq .= "'".$ret["syslog_server_db_password"]."' ": $rq .= "NULL ";

		$rq .= "WHERE sopt_id = '".$sopt_id."'";
		$DBRESULT =& $pearDB->query($rq);
		if (PEAR::isError($DBRESULT))
			print $DBRESULT->getDebugInfo()."<br>";

	}

	function getFilterHosts()	{
		global $pear_syslogDB, $syslogOpt;

		if ($syslogOpt["syslog_db_filter"] != NULL)
			$query = "SELECT distinct(value) as host FROM " . $syslogOpt["syslog_db_filter"] . " WHERE type= \"HOST\" ORDER BY host ASC";
		else
			$query = "SELECT distinct(host) FROM " . $syslogOpt["syslog_db_table"] . "  ORDER BY host ASC";

		$res =& $pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ". $pear_syslogDB->getMessage();
		}
		# Set base value
		$FilterHosts  =  array("" => "");
		
		while ($host =& $res->fetchRow())
			$FilterHosts[$host['host']] = $host['host']; 
			
		$FilterHosts = array_map("myDecode",$FilterHosts  );
		return $FilterHosts;
	}
	
	function getFilterFacilities()	{
		global $pear_syslogDB, $syslogOpt;

		if ($syslogOpt["syslog_db_filter"] != NULL)
			$query = "SELECT distinct(value) as facility FROM " . $syslogOpt["syslog_db_filter"] . " WHERE type= \"FACILITY\"  ORDER BY facility ASC";
		else
			$query = "SELECT distinct(facility) FROM " . $syslogOpt["syslog_db_table"] . "  ORDER BY facility ASC";

		$res =& $pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ". $pear_syslogDB->getMessage();
		}
		# Set base value
		$FilterFacilities  =  array("" => "");
		
		while ($facility =& $res->fetchRow())
			$FilterFacilities[$facility['facility']] = $facility['facility']; 
			
		$FilterFacilities = array_map("myDecode",$FilterFacilities );
		return $FilterFacilities;
	}
		 
	function getFilterPriorities()	{
		global $pear_syslogDB, $syslogOpt;

		if ($syslogOpt["syslog_db_filter"] != NULL)
			$query = "SELECT distinct(value) as priority FROM " . $syslogOpt["syslog_db_filter"] . " WHERE type= \"PRIORITY\"  ORDER BY priority ASC";
		else
			$query = "SELECT distinct(priority) FROM " . $syslogOpt["syslog_db_table"] . "  ORDER BY priority ASC";

		$res =& $pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ". $pear_syslogDB->getMessage();
		}
		# Set base value
		$FilterPriorities  =  array("" => "");
		
		while ($priority =& $res->fetchRow())
			$FilterPriorities[$priority['priority']] = $priority['priority']; 
			
		$FilterPriorities = array_map("myDecode",$FilterPriorities );
		return $FilterPriorities;
	}
 
	function getFilterLevels()	{
		global $pear_syslogDB;
		global $syslogOpt;

		if ($syslogOpt["syslog_db_filter"] != NULL)
			$query = "SELECT distinct(value) as level FROM " . $syslogOpt["syslog_db_filter"] . " WHERE type= \"LEVEL\"  ORDER BY level ASC";
		else
			$query = "SELECT distinct(level) FROM " . $syslogOpt["syslog_db_table"] . "  ORDER BY level ASC";

		$res =& $pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ". $pear_syslogDB->getMessage();
		}
		# Set base value
		$FilterLevels  = array("" => "");
		
		while ($level =& $res->fetchRow())
			$FilterLevels[$level['level']] = $level['level']; 
			
		$FilterLevels = array_map("myDecode",$FilterLevels );
		return $FilterLevels;
	}

	function getFilterTags()	{
		global $pear_syslogDB;
		global $syslogOpt;

		if ($syslogOpt["syslog_db_filter"] != NULL)
			$query = "SELECT distinct(value) as tag FROM " . $syslogOpt["syslog_db_filter"] . " WHERE type= \"TAG\"  ORDER BY tag ASC";
		else
			$query = "SELECT distinct(tag) FROM " . $syslogOpt["syslog_db_table"] . "  ORDER BY tag ASC";

		$res =& $pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ". $pear_syslogDB->getMessage();
		}
		# Set base value
		$FilterTags  =  array("" => "");
		
		while ($tag =& $res->fetchRow())
			$FilterTags[$tag['tag']] = $tag['tag']; 
			
		$FilterTags  = array_map("myDecode",$FilterTags  );
		return $FilterTags ;
	}	
	
	function getFilterPrograms()	{
		global $pear_syslogDB;
		global $syslogOpt;

		if ($syslogOpt["syslog_db_filter"] != NULL)
			$query = "SELECT distinct(value) as program FROM " . $syslogOpt["syslog_db_filter"] . " WHERE type= \"PROGRAM\"  ORDER BY program ASC";
		else
			$query = "SELECT distinct(program) FROM " . $syslogOpt["syslog_db_table"] . " ORDER BY program ASC";

		$res =& $pear_syslogDB->query($query);
		
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ". $pear_syslogDB->getMessage();
		}
		# Set base value
		$FilterPrograms  = array("" => "");
		
		while ($program =&$res->fetchRow())
				$FilterPrograms[$program['program']] = $program['program'] ; 
		
		//	array_push($FilterPrograms, $program['program']); 
			
		$FilterPrograms  = array_map("myDecode",$FilterPrograms );
		return $FilterPrograms ;
	}	

?>
