<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * Module name: Syslog
 * 
 * First developpement by : Jean Marc Grisard - Christophe Coraboeuf
 * 
 * Adaptation for Centreon 2.0 by : Merethis team 
 * 
 * SVN : $URL
 * SVN : $Id$
 * 
 */
	require_once ($centreon_path . "www/class/Session.class.php");
	require_once ($centreon_path . "www/class/Oreon.class.php");
	Session::start();
	
	# Get language 
	$locale = $oreon->user->get_lang();
	putenv("LANG=$locale");
	setlocale(LC_ALL, $locale);
	bindtextdomain("messages", "./modules/Syslog/locale/");
	bind_textdomain_codeset("messages", "UTF-8"); 
	textdomain("messages");
	
	# Pagination
	include("./include/common/autoNumLimit.php");
	
	# Pear library
	require_once "HTML/QuickForm.php";
	require_once 'HTML/QuickForm/advmultiselect.php';
	require_once 'HTML/QuickForm/Renderer/ArraySmarty.php';
	
	# PHP functions
	require_once "./modules/Syslog/include/common-Func.php";
	require_once "./include/common/common-Func.php";
	
	# Path to the configuration dir
	global $path;
	$path = "./modules/Syslog/";
	require_once $path."/include/DBconnect.php";
	$syslogOpt = getSyslogOpt();
	
	# QuickSearch form
	include_once("./include/common/quickSearch.php");
	
	# Set limit & num
	$DBRESULT =& $pearDB->query("SELECT maxViewMonitoring FROM general_opt LIMIT 1");
	if (PEAR::isError($DBRESULT))
		print "Mysql Error : ".$DBRESULT->getMessage();
	$gopt = array_map("myDecode", $DBRESULT->fetchRow());
	
	# Get end Post values
	isset ($_GET["num"]) ? $num = $_GET["num"] : $num = 0;
	isset ($_GET["search"]) ? $search = $_GET["search"] : $search = NULL;
	
	# Get filters values from post form
	( isset($_POST["filter_program"]) && ($_POST["filter_program"] != ""  )) ? $filter_programP = $_POST["filter_program"] : $filter_programP = NULL;
	( isset($_GET["filter_program"]) && ($_GET["filter_program"] != ""  )) ? $filter_programG = $_GET["filter_program"] : $filter_programG = NULL;	
	( isset($_POST["filter_host"]) && ($_POST["filter_host"] != "" )) ? $filter_hostP = $_POST["filter_host"] : $filter_hostP = NULL;
	( isset($_GET["filter_host"]) && ($_GET["filter_host"] != "" )) ? $filter_hostG = $_GET["filter_host"] : $filter_hostG = NULL;	
	( isset($_POST["filter_facility"]) && ($_POST["filter_facility"] != "" )) ? $filter_facilityP = $_POST["filter_facility"] : $filter_facilityP = NULL;
	( isset($_GET["filter_facility"]) && ($_GET["filter_facility"] != "" )) ? $filter_facilityG = $_GET["filter_facility"] : $filter_facilityG = NULL;	
 	( isset($_POST["filter_priority"]) && ($_POST["filter_priority"] != "" )) ? $filter_priorityP = $_POST["filter_priority"] : $filter_priorityP = NULL;
 	( isset($_GET["filter_priority"]) && ($_GET["filter_priority"] != "" )) ? $filter_priorityG = $_GET["filter_priority"] : $filter_priorityG = NULL; 	
 	( isset($_POST["filter_tag"]) && ($_POST["filter_tag"] != "" )) ? $filter_tagP = $_POST["filter_tag"] : $filter_tagP = NULL;
	( isset($_GET["filter_tag"]) && ($_GET["filter_tag"] != "" )) ? $filter_tagG = $_GET["filter_tag"] : $filter_tagG = NULL; 		
 	( isset($_POST["filter_msg"]) && ($_POST["filter_msg"] != "" )) ? $filter_msgP = $_POST["filter_msg"] : $filter_msgP = NULL;
 	( isset($_GET["filter_msg"]) && ($_GET["filter_msg"] != "" )) ? $filter_msgG = $_GET["filter_msg"] : $filter_msgG = NULL; 	
 
	if (isset($_GET["StartDate"])) {
		$start_date = $_GET["StartDate"];
		$StartDate = mktime (0, 0, 0, substr($start_date, 0, 2), substr($start_date, 3, 2), substr($start_date, 6, 4));
	} else if (isset($_POST["StartDate"])) {
		$start_date = $_POST["StartDate"];
		$StartDate = mktime (0, 0, 0, substr($start_date, 0, 2), substr($start_date, 3, 2), substr($start_date, 6, 4));
	} else
		$StartDate =  time();
		
	if (isset($_GET["EndDate"])) {
		$end_date = $_GET["EndDate"];
		$EndDate = mktime (0, 0, 0, substr($end_date, 0, 2), substr($end_date, 3, 2), substr($end_date, 6, 4));
	} else if (isset($_POST["EndDate"])) {
		$end_date = $_POST["EndDate"];
		$EndDate = mktime (0, 0, 0, substr($end_date, 0, 2), substr($end_date, 3, 2), substr($end_date, 6, 4));
	} else
		$EndDate = time();

	if (isset($_GET["StartTime"])) {
		$StartTime = $_GET["StartTime"];
	} else if (isset($_POST["StartTime"])) {
		$StartTime = $_POST["StartTime"];
	} else
		$StartTime = (Date("H")-1).":".Date("i");
		
	if (isset($_GET["EndTime"])) {
		$EndTime = $_GET["EndTime"];
	} else if (isset($_POST["EndTime"])) {
		$EndTime = $_POST["EndTime"];
	} else
		$EndTime = Date("H:i");
		
		
	if (isset($_POST["end_hidden"])) {
		$end_date = $_POST["end_hidden"];
		$EndDate = mktime (0, 0, 0, substr($end_date, 0, 2), substr($end_date, 3, 2), substr($end_date, 6, 4));
	}
	if (isset($_POST["start_hidden"]))	{
		$start_date = $_POST["start_hidden"];
		$StartDate = mktime (0, 0, 0, substr($start_date, 0, 2), substr($start_date, 3, 2), substr($start_date, 6, 4));
	}
	
	if (isset($_POST["start_time"]))
		$StartTime = $_POST["start_time"];
		
	if (isset($_POST["end_time"]))
		$EndTime = $_POST["end_time"];
 
	$filter_program = ( isset($filter_programP) ) ? $filter_program = $filter_programP :$filter_program = $filter_programG ;
	$filter_host = ( isset($filter_hostP)) ? $filter_host = $filter_hostP  : $filter_host = $filter_hostG;
	$filter_facility = ( isset($filter_facilityP)) ? $filter_facility = $filter_facilityP  : $filter_facility = $filter_facilityG;
	$filter_priority = ( isset($filter_priorityP)) ? $filter_priority = $filter_priorityP  : $filter_priority = $filter_priorityG;
	$filter_tag = ( isset($filter_tagP)) ? $filter_tag = $filter_tagP  : $filter_tag = $filter_tagG;
	$filter_msg = ( isset($filter_msgP)) ? $filter_msg = $filter_msgP  : $filter_msg = $filter_msgG;
	
	$sql_filter = array();
	
	if (isset($filter_program) )
		array_push($sql_filter ," (program = '". htmlentities($filter_program , ENT_QUOTES) ."')  ");
	
	if (isset($filter_host) )
		array_push($sql_filter ," (host = '". htmlentities($filter_host , ENT_QUOTES) ."')  ");	
	
	if (isset($filter_facility) )
		array_push($sql_filter ," (facility = '". htmlentities($filter_facility , ENT_QUOTES) ."')  ");
		
	if (isset($filter_priority) )
		array_push($sql_filter ," (priority = '". htmlentities($filter_priority , ENT_QUOTES) ."')  ");
		
	if (isset($filter_tag) )
		array_push($sql_filter ," (tag = '". htmlentities($filter_tag , ENT_QUOTES) ."')  ");							

	if (isset($filter_msg) )
		array_push($sql_filter ," (msg LIKE '%". htmlentities($filter_msg , ENT_QUOTES) ."%')  ");	
		
	if (isset($StartDate))
		$start_sql = strftime("%Y-%m-%d " , $StartDate).$StartTime;
	
	if (isset($EndDate))
		$end_sql = strftime("%Y-%m-%d " , $EndDate).$EndTime;

	if (isset( $sql_filter ))
		$req_sql_filter = join(" AND " , $sql_filter);

	if($search) {
			$req = "SELECT * FROM ".$syslogOpt["syslog_db_table"] . " WHERE msg LIKE '%".htmlentities($search, ENT_QUOTES)."%' ORDER BY datetime ";
	} else {
		if (count( $sql_filter ) > 0 ) 
			$req = "SELECT * FROM ".$syslogOpt["syslog_db_table"] . " WHERE datetime > '$start_sql' AND datetime <= '$end_sql' AND " .  $req_sql_filter . " ORDER BY datetime";
		else
			$req = "SELECT * FROM ".$syslogOpt["syslog_db_table"] . " WHERE datetime > '$start_sql' AND datetime <= '$end_sql' ORDER BY datetime";
	}
	
	$DBRESULT =& $pear_syslogDB->query($req);
		if (PEAR::isError($DBRESULT))
				print "Mysql Error : ".$DBRESULT->getMessage();
		
		if (PEAR::isError($DBRESULT))
			print "Mysql Error : ".$DBRESULT->getMessage();
		$rows = $DBRESULT->numrows();
		
		if(($num * $limit) > $rows)
			$num = round($rows / $limit) - 1;
		$lstart = $num * $limit;
	
		if ($lstart <= 0)
			$lstart = 0;

	$query = $req  . " DESC LIMIT $lstart,$limit";
	
	$DBRESULT1 =& $pear_syslogDB->query($query);
		if (PEAR::isError($DBRESULT1))
				print "Mysql Error : ".$DBRESULT1->getMessage();
	
	$elemArr = array();
	while ($DBRESULT1->fetchInto($data)) {
		$elemArr[] = array("RowMenu_datetime"=>$data["datetime"],
						"RowMenu_host"=>$data["host"],
						"RowMenu_facility"=>$data["facility"],
						"RowMenu_priority"=>$data["priority"],
						"RowMenu_tag"=>$data["tag"],
						"RowMenu_program"=>$data["program"],
						"RowMenu_msg"=>htmlentities($data["msg"]));
	}
	
	# Smarty template Init
	$tpl = new Smarty();
	$path = $path."search/";
	$tpl = initSmartyTpl($path, $tpl);
	$tpl->assign('startDate', date("m/d/Y", $StartDate));
	$tpl->assign('endDate', date("m/d/Y", $EndDate));
	$tpl->assign('startTime', $StartTime);
	$tpl->assign('endTime', $EndTime);
	$tpl->assign("MODULE_TITLE", _("Syslog"));
	$tpl->assign("FILTER_TITLE", _("Syslog filters parameters :"));
	$tpl->assign("headerMenu_datetime", _("Date / Time"));
	$tpl->assign("headerMenu_host", _("Host"));
	$tpl->assign("headerMenu_facility", _("Facility"));
	$tpl->assign("headerMenu_priority", _("Priority"));
	$tpl->assign("headerMenu_tag", _("Tag"));
	$tpl->assign("headerMenu_program", _("Program"));
	$tpl->assign("headerMenu_msg", _("Message"));
	$tpl->assign('limit', $limit);
	
	# Attributs definition for form_filter quickform
	$attrsText = array("size"=>"100%");
	$attrsTextDate 	= array("size"=>"11", "style"=>"font-family:Verdana, Tahoma;font-size:9px;height:13px;border: 0.5px solid gray;");
	$attrsTextHour 	= array("size"=>"5", "style"=>"font-family:Verdana, Tahoma;font-size:9px;height:13px;border: 0.5px solid gray;");
	
	# QuickForm form_filter
	$form_filter = new HTML_QuickForm('Formfilter', 'post', "?p=".$p);
	
	$FilterHosts = array();
	$FilterHosts = getFilterHosts();
	$form_filter->addElement('select', 'filter_host', " ", $FilterHosts);
	$form_filter->setDefaults(array('filter_host' => $filter_host));  
		
	$FilterFacilities = array();
	$FilterFacilities = getFilterFacilities();
	$form_filter->addElement('select', 'filter_facility', " ", $FilterFacilities);
	$form_filter->setDefaults(array('filter_facility' => $filter_facility));  
	
	$FilterPriorities = array();
	$FilterPriorities = getFilterPriorities();
	$form_filter->addElement('select', 'filter_priority', " ", $FilterPriorities);
	$form_filter->setDefaults(array('filter_priority' => $filter_priority)); 
	
	$FilterTags = array();
	$FilterTags = getFilterTags();
	$form_filter->addElement('select', 'filter_tag', " ", $FilterTags);
	$form_filter->setDefaults(array('filter_tag' => $filter_tag)); 
	
	$FilterPrograms = array();
	$FilterPrograms = getFilterPrograms();
	$form_filter->addElement('select', 'filter_program', " ", $FilterPrograms);
	$form_filter->setDefaults(array('filter_program' => $filter_program)); 
	
	$form_filter->addElement('text', 'filter_msg', "", $attrsText );
	$form_filter->addElement('text', 'start_date', _("From"), $attrsTextDate);
	$form_filter->addElement('text', 'start_time', '', $attrsTextHour);
	$form_filter->addElement('text', 'end_date', _("To"), $attrsTextDate);
	$form_filter->addElement('text', 'end_time',  '', $attrsTextHour);
	
	if (!isset($filter_start_date))
		$filter_start_date = "";
	if (!isset($filter_end_date))
		$filter_end_date = "";
	if (!isset($filter_start_time))
		$filter_start_time = "";
	if (!isset($filter_end_time))
		$filter_end_time = "";
		
	$tab_value = array("filter_start_date"=>$filter_start_date, "filter_end_date"=>$filter_end_date, 
		"filter_start_time"=>$filter_start_time,"filter_end_time"=>$filter_end_time);
   	$form_filter->setDefaults($tab_value);
	
	$form_filter->addElement('submit', 'filter_search',  _("filter") );
	$form_filter->addElement('reset', 'reset',  _("reset"));
	$renderer_filter =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
	$form_filter->accept($renderer_filter);
	$tpl->assign('Formfilter', $renderer_filter->toArray());
	
	$form = new HTML_QuickForm('Formfilterhidden');
	
	$form->addElement('hidden', 'filter_host');
	$form->addElement('hidden', 'filter_facility');
	$form->addElement('hidden', 'filter_priority');
	$form->addElement('hidden', 'filter_tag');
	$form->addElement('hidden', 'filter_program');
	$form->addElement('hidden', 'filter_msg');
	$form->addElement('hidden', 'start_hidden');
	$form->addElement('hidden', 'start_time');	
	$form->addElement('hidden', 'end_hidden');
	$form->addElement('hidden', 'end_time');

	$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
	$form->accept($renderer);
	$tpl->assign('Formfilterhidden', $renderer->toArray());

	$tpl->assign("elemArr", $elemArr);
	$tpl->display("syslog_search.ihtml");
?>