<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * Module name: Syslog
 * 
 * First developpement by : Jean Marc Grisard - Christophe Coraboeuf
 * 
 * Adaptation for Centreon 2.0 by : Merethis team 
 * 
 * SVN : $URL
 * SVN : $Id$
 * 
 */

	if (!isset($oreon))
		exit();

	isset($_GET["sopt_id"]) ? $sG = $_GET["sopt_id"] : $sG = NULL;
	isset($_POST["sopt_id"]) ? $sP = $_POST["sopt_id"] : $sP = NULL;
	$sG ? $sopt_id = $sG : $sopt_id = $sP;

	#Pear library
	require_once "HTML/QuickForm.php";
	require_once 'HTML/QuickForm/advmultiselect.php';
	require_once 'HTML/QuickForm/Renderer/ArraySmarty.php';

	/*
	 * Init Language 
	 */
	$locale = $oreon->user->get_lang();
	putenv("LANG=$locale");
	setlocale(LC_ALL, $locale);
	bindtextdomain("messages", "./modules/Syslog/locale/");
	bind_textdomain_codeset("messages", "UTF-8"); 
	textdomain("messages");


	#Path to the configuration dir
	global $path;
	$path = "./modules/Syslog/";

	#PHP functions
	require_once $path."include/common-Func.php";
	?>
	<script type="text/javascript">
		function ajax_generate()
		{
		    var xhr=null;
		    
		    if (window.XMLHttpRequest) { 
		        xhr = new XMLHttpRequest();
		    }
		    else if (window.ActiveXObject) 
		    {
		        xhr = new ActiveXObject("Microsoft.XMLHTTP");
		    }
		    xhr.onreadystatechange = function() { alert_ajax(xhr); };
		    
		    xhr.open('GET', "./modules/Syslog/export/ssh_export.php", true);
		    xhr.send(null);
		}
		
		function alert_ajax(xhr)
		{
			var docXML= xhr.responseXML;
			var items = docXML.getElementsByTagName("status");
			
			alert (items.item(0).firstChild.data);
		}
	</script>
	<?php

	#
	## Database retrieve information for LCA
	#
	$sopt = getSyslogOpt();
	#
	## Database retrieve information for differents elements list we need on the page
	#
	#
	# End of "database-retrieved" information
	##########################################################
	##########################################################
	# Var information to format the element
	#

	$attrsText 		= array("size"=>"50");
	$attrsText2		= array("size"=>"20");
	$attrsText3		= array("size"=>"5");
	$attrsAdvSelect = null;
	#
	## Form begin
	#
	$form = new HTML_QuickForm('Form', 'post', "?p=".$p);
	$form->addElement('header', 'title', _("Syslog"));

	$form->addElement('header', 'syslogng_header', _("Syslog Options"));
	$form->addElement('text', 'syslog_server', _("Syslog DB Server"), $attrsText );
	$form->addElement('text', 'syslog_db', _("Syslog DB Name"), $attrsText );
	$form->addElement('text', 'syslog_db_table', _("Syslog Table Name"), $attrsText );
	$form->addElement('text', 'syslog_db_filter', _("Syslog Filters Table Name"), $attrsText );
	$form->addElement('text', 'syslog_db_rotate', _("Syslog retention"), $attrsText);
	$form->addElement('text', 'syslog_server_db_user', _("Syslog User"), $attrsText2 );
	$form->addElement('password', 'syslog_server_db_password', _("Syslog Password"), $attrsText2);
	$form->addElement('text', 'syslog_shell_user', _("Name of syslog user on Syslog server"), $attrsText2);
	$form->addElement('password', 'syslog_shell_pass', _("Password for distant user on Syslog server"), $attrsText2);
	$form->addElement('text', 'syslog_conf_dir', _("Syslog configuration directory"), $attrsText);
	$form->addElement('text', 'syslog_ssh_port', _("SSH port for connection to Syslog server"), $attrsText3);


	$form->addElement('hidden', 'sopt_id');
	$redirect =& $form->addElement('hidden', 'o');
	$redirect->setValue($o);

	#
	## Form Rules
	#
	function slash($elem = NULL)	{
		if ($elem)
			return rtrim($elem, "/")."/";
	}
	$form->applyFilter('_ALL_', 'trim');
	$form->addRule('syslog_server', _("Required Field"), 'required');
	$form->addRule('syslog_db', _("Required Field"), 'required');
	$form->addRule('syslog_db_table', _("Required Field"), 'required');
	$form->addRule('syslog_db_filter', _("Required Field"), 'required');
	$form->addRule('syslog_db_rotate', _("Required Field"), 'required');
	$form->addRule('syslog_conf_dir', _("Required Field"), 'required');
	$form->addRule('syslog_shell_pass', _("Required Field"), 'required');
	$form->addRule('syslog_ssh_port', _("Required Field"), 'required');
	$form->addRule('syslog_server_db_user', _("Required Field"), 'required');

	#
	##End of form definition
	#

	# Smarty template Init
	$tpl = new Smarty();
	$tpl = initSmartyTpl($path, $tpl);

	$form->setDefaults($sopt);

	$subC =& $form->addElement('submit', 'submitC', _("save"));
	$DBRESULT =& $form->addElement('reset', 'reset', _("reset"));


    $valid = false;
	if ($form->validate())	{

		# Update in DB
		updateSyslogConfigData($form->getSubmitValue("sopt_id"));
		$o = "w";
   		$valid = true;
		$form->freeze();

	}
	if (!$form->validate() && isset($_POST["sopt_id"]))	{
	    print("<div class='msg' align='center'>".$lang["quickFormError"]."</div>");
	}

	$form->addElement("button", "change", _("modify"), array("onClick"=>"javascript:window.location.href='?p=".$p."&o=Syslog'"));
	$form->addElement("button", "ajax",  _("Export configuration"), array( "id" => "ajaxBtn", "onClick" => "javascript:ajax_generate();") );
	#
	##Apply a template definition
	#

	$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
	$renderer->setRequiredTemplate('{$label}&nbsp;<font color="red" size="1">*</font>');
	$renderer->setErrorTemplate('<font color="red">{$error}</font><br />{$html}');
	$form->accept($renderer);
	$tpl->assign('form', $renderer->toArray());
	$tpl->assign('o', $o);
	$tpl->assign('valid', $valid);
	$tpl->display("syslog_options.ihtml");
?>