<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * Module name: Syslog
 * 
 * First developpement by : Jean Marc Grisard - Christophe Coraboeuf
 * 
 * Adaptation for Centreon 2.0 by : Merethis team 
 * 
 * SVN : $URL
 * SVN : $Id$
 * 
 */
 
 	# Control user identity
	if (!isset ($oreon))
		exit ();
		
	# Get language 
	$locale = $oreon->user->get_lang();
	putenv("LANG=$locale");
	setlocale(LC_ALL, $locale);
	bindtextdomain("messages", "./modules/Syslog/locale/");
	bind_textdomain_codeset("messages", "UTF-8"); 
	textdomain("messages");
	
	require_once("./modules/Syslog/view/javascript/syslog_js.php");
	
	# Pagination
	include("./include/common/autoNumLimit.php");
	
	# Pear library
	require_once "HTML/QuickForm.php";
	require_once 'HTML/QuickForm/advmultiselect.php';
	require_once 'HTML/QuickForm/Renderer/ArraySmarty.php';
	
	# PHP functions
	require_once "./modules/Syslog/include/common-Func.php";
	require_once "./include/common/common-Func.php";
	
	# Path to the configuration dir
	global $path;
	$path = "./modules/Syslog/";
	require_once $path."/include/DBconnect.php";
	$syslogOpt = getSyslogOpt();
	
	# QuickSearch form
	include_once("./include/common/quickSearch.php");
	
	# Smarty template Init
	$tpl = new Smarty();
	$tpl = initSmartyTpl($path . "/view/template", $tpl);
	$tpl->assign("MODULE_TITLE", _("Syslog"));
	$tpl->assign("FILTER_TITLE", _("Syslog filters parameters :"));
	$tpl->assign("headerMenu_datetime", _("Date / Time"));
	$tpl->assign("headerMenu_host", _("Host"));
	$tpl->assign("headerMenu_facility", _("Facility"));
	$tpl->assign("headerMenu_priority", _("Priority"));
	$tpl->assign("headerMenu_tag", _("Tag"));
	$tpl->assign("headerMenu_program", _("Program"));
	$tpl->assign("headerMenu_msg", _("Message"));
	$tpl->assign('limit', $limit);
	$tpl->assign("Refresh", _("Refresh:"));
	
	# Attributs definition for form_filter quickform
	$attrsText = array("size"=>"100%");
	$attrsTextDate 	= array("size"=>"11", "style"=>"font-family:Verdana, Tahoma;font-size:9px;height:13px;border: 0.5px solid gray;");
	$attrsTextHour 	= array("size"=>"5", "style"=>"font-family:Verdana, Tahoma;font-size:9px;height:13px;border: 0.5px solid gray;");
	
	# QuickForm form_filter
	$form_filter = new HTML_QuickForm('Formfilter', 'post', "?p=".$p);
	
	$FilterHosts = array();
	$FilterHosts = getFilterHosts();
	$form_filter->addElement('select', 'filter_host', " ", $FilterHosts, array("id" => "filter_host", "onChange" => "javascript:build_ajax();"));
	$form_filter->setDefaults(array('filter_host' => $filter_host));  
		
	$FilterFacilities = array();
	$FilterFacilities = getFilterFacilities();
	$form_filter->addElement('select', 'filter_facility', " ", $FilterFacilities, array("id" => "filter_facility", "onChange" => "javascript:build_ajax();"));
	$form_filter->setDefaults(array('filter_facility' => $filter_facility));  
	
	$FilterPriorities = array();
	$FilterPriorities = getFilterPriorities();
	$form_filter->addElement('select', 'filter_priority', " ", $FilterPriorities, array("id" => "filter_priority", "onChange" => "javascript:build_ajax();"));
	$form_filter->setDefaults(array('filter_priority' => $filter_priority)); 
	
	$FilterTags = array();
	$FilterTags = getFilterTags();
	$form_filter->addElement('select', 'filter_tag', " ", $FilterTags, array("id" => "filter_tag", "onChange" => "javascript:build_ajax();"));
	$form_filter->setDefaults(array('filter_tag' => $filter_tag)); 
	
	$FilterPrograms = array();
	$FilterPrograms = getFilterPrograms();
	$form_filter->addElement('select', 'filter_program', " ", $FilterPrograms, array("id" => "filter_program", "onChange" => "javascript:build_ajax();"));
	$form_filter->setDefaults(array('filter_program' => $filter_program)); 
	
	$form_filter->addElement('button', 'ajax',  _("stop"), array( "id" => "ajaxBtn", "onClick" => "javascript:ajax_handler(this.value);") );
	$renderer_filter =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
	$form_filter->accept($renderer_filter);
	$tpl->assign('Formfilter', $renderer_filter->toArray());
	
	$form = new HTML_QuickForm('Formfilterhidden');
	
	$form->addElement('hidden', 'filter_host');
	$form->addElement('hidden', 'filter_facility');
	$form->addElement('hidden', 'filter_priority');
	$form->addElement('hidden', 'filter_tag');
	$form->addElement('hidden', 'filter_program');
	$form->addElement('hidden', 'filter_msg');

	$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
	$form->accept($renderer);
	$tpl->assign('Formfilterhidden', $renderer->toArray());

	$tpl->assign("elemArr", $elemArr);
	$tpl->display("syslog.ihtml");
?>
<script type="text/javascript">
build_ajax();
hidePagination();
</script>
